From de9a5b12b30518bc9f66d4d86b8f460b960194c9 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Oct 31 2020 19:17:42 +0000
Subject: [PATCH 1104/2232] Guarantee trivial copy constructor and destructor for Str and Slice


Repro:

    const char *ptr(Str str) { return str.repr.ptr; }
    size_t len(Str str) { return str.repr.len; }

Before:

    ptr(Str):
        mov     rax, qword ptr [rdi]
        ret
    len(Str):
        mov     rax, qword ptr [rdi + 8]
        ret

After:

    ptr(Str):
        mov     rax, rdi
        ret
    len(Str):
        mov     rax, rsi
        ret

---

diff --git a/include/cxx.h b/include/cxx.h
index 7b332b4..9f0bf46 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -56,8 +56,6 @@ private:
 class Str final {
 public:
   Str() noexcept;
-  Str(const Str &) noexcept;
-
   Str(const std::string &);
   Str(const char *);
   Str(const char *, size_t);
@@ -72,6 +70,10 @@ public:
   size_t size() const noexcept;
   size_t length() const noexcept;
 
+  // Important in order for System V ABI to pass in registers.
+  Str(const Str &) noexcept = default;
+  ~Str() noexcept = default;
+
   // Repr is PRIVATE; must not be used other than by our generated code.
   //
   // Not necessarily ABI compatible with &str. Codegen will translate to
@@ -93,7 +95,6 @@ template <typename T>
 class Slice final {
 public:
   Slice() noexcept;
-  Slice(const Slice<T> &) noexcept;
   Slice(const T *, size_t count) noexcept;
 
   Slice &operator=(Slice<T>) noexcept;
@@ -102,6 +103,10 @@ public:
   size_t size() const noexcept;
   size_t length() const noexcept;
 
+  // Important in order for System V ABI to pass in registers.
+  Slice(const Slice<T> &) noexcept = default;
+  ~Slice() noexcept = default;
+
   // Repr is PRIVATE; must not be used other than by our generated code.
   //
   // At present this class is only used for &[u8] slices.
@@ -318,9 +323,6 @@ template <typename T>
 Slice<T>::Slice() noexcept : repr(Repr{reinterpret_cast<const T *>(this), 0}) {}
 
 template <typename T>
-Slice<T>::Slice(const Slice<T> &) noexcept = default;
-
-template <typename T>
 Slice<T>::Slice(const T *s, size_t count) noexcept : repr(Repr{s, count}) {}
 
 template <typename T>
diff --git a/src/cxx.cc b/src/cxx.cc
index 254072e..96a1861 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -117,8 +117,6 @@ std::ostream &operator<<(std::ostream &os, const String &s) {
 
 Str::Str() noexcept : repr(Repr{reinterpret_cast<const char *>(1), 0}) {}
 
-Str::Str(const Str &) noexcept = default;
-
 static void initStr(Str::Repr repr) {
   if (!cxxbridge05$str$valid(repr.ptr, repr.len)) {
     panic<std::invalid_argument>("data for rust::Str is not utf-8");

